/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.log.enums.YYLoggerTuJingEnum
 *  fire.pb.activity.award.RewardMgr
 *  fire.pb.battle.pvp.PvPHelper
 *  fire.pb.course.CourseManager
 *  fire.pb.main.ConfigManager
 *  fire.pb.map.MapConfig
 *  fire.pb.map.Transfer
 *  fire.pb.mission.activelist.RoleLiveness
 *  fire.pb.talk.MessageMgr
 *  fire.pb.team.PQuitTeamProc
 *  fire.pb.team.Team
 *  fire.pb.team.TeamManager
 *  fire.pb.util.StringConstant
 *  gnet.link.Onlines
 *  mkdb.Procedure
 *  mkdb.Transaction
 *  mkio.Protocol
 *  xbean.Pod
 *  xbean.PvP5Role
 *  xtable.Properties
 *  xtable.Pvp5roles
 */
package fire.pb.battle.pvp5;

import fire.log.enums.YYLoggerTuJingEnum;
import fire.pb.activity.award.RewardMgr;
import fire.pb.battle.pvp.PvPHelper;
import fire.pb.battle.pvp5.PvP5CampPolicy;
import fire.pb.battle.pvp5.PvP5Control;
import fire.pb.battle.pvp5.PvP5Helper;
import fire.pb.battle.pvp5.PvP5RaceProxy;
import fire.pb.battle.pvp5.PvP5RoleStateManager;
import fire.pb.battle.pvp5.SPvP5MyInfo;
import fire.pb.battle.pvp5.SPvP5OpenBoxState;
import fire.pb.course.CourseManager;
import fire.pb.main.ConfigManager;
import fire.pb.map.MapConfig;
import fire.pb.map.Transfer;
import fire.pb.mission.activelist.RoleLiveness;
import fire.pb.talk.MessageMgr;
import fire.pb.team.PQuitTeamProc;
import fire.pb.team.Team;
import fire.pb.team.TeamManager;
import fire.pb.util.StringConstant;
import gnet.link.Onlines;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import mkdb.Procedure;
import mkdb.Transaction;
import mkio.Protocol;
import xbean.Pod;
import xbean.PvP5Role;
import xtable.Properties;
import xtable.Pvp5roles;

public class PvP5RoleProxy {
    private final long roleId;
    private PvP5Role xpvprole;
    private final boolean readonly;

    public static PvP5RoleProxy getPvP5RoleProxy(long roleId, boolean readonly) {
        PvP5Role xpvprole = null;
        xpvprole = readonly ? Pvp5roles.select((Long)roleId) : Pvp5roles.get((Long)roleId);
        if (xpvprole == null) {
            if (readonly) {
                xpvprole = Pod.newPvP5RoleData();
            } else {
                xpvprole = Pod.newPvP5Role();
                Pvp5roles.insert((Long)roleId, (PvP5Role)xpvprole);
            }
        }
        return new PvP5RoleProxy(roleId, xpvprole, readonly);
    }

    public PvP5RoleProxy(long roleId, PvP5Role xpvprole, boolean readonly) {
        this.roleId = roleId;
        this.xpvprole = xpvprole;
        this.readonly = readonly;
    }

    public void clearBattleInfo() {
        this.xpvprole.setBattlenum(0);
        this.xpvprole.setWinnum(0);
        this.xpvprole.setContinuewinnum(0);
        this.xpvprole.setFirstwinaward(0);
        this.xpvprole.setFivebattleaward(0);
    }

    public long getRoleId() {
        return this.roleId;
    }

    public int getGrade() {
        return this.xpvprole.getGrade();
    }

    public int getCamp() {
        return this.xpvprole.getCamp();
    }

    public int getExcellent() {
        return this.xpvprole.getExcellent();
    }

    public int getScore() {
        return this.xpvprole.getScore();
    }

    public int getScoreLevel() {
        return PvPHelper.getScoreLevel((int)this.getScore());
    }

    public int getBattleNum() {
        return this.xpvprole.getBattlenum();
    }

    public int getWinNum() {
        return this.xpvprole.getWinnum();
    }

    public int getContinueWinNum() {
        return this.xpvprole.getContinuewinnum();
    }

    public long getLastBattleTime() {
        return this.xpvprole.getLastbattletime();
    }

    public long getLastEnterTime() {
        return this.xpvprole.getLastentertime();
    }

    public boolean isTodayJoinActivity() {
        return PvP5Control.getInstance().isActivityTime(this.xpvprole.getLastentertime());
    }

    public int getGradeInActivity() {
        if (PvP5Control.getInstance().isActivityTime(this.xpvprole.getLastentertime()) && this.xpvprole.getGrade() > 0) {
            return this.xpvprole.getGrade();
        }
        return -1;
    }

    public void onEnter(int grade, int mapId) {
        boolean isFirst = false;
        long now = System.currentTimeMillis();
        if (!PvP5Control.getInstance().isActivityTime(this.xpvprole.getLastentertime())) {
            this.clearBattleInfo();
            this.xpvprole.setLastbattletime(0L);
            this.xpvprole.setScore(0);
            isFirst = true;
        }
        int camp = PvP5Helper.getCampByMapId(mapId);
        int excellent = PvP5Helper.getExcellentByMapId(mapId);
        this.xpvprole.setGrade(grade);
        this.xpvprole.setCamp(camp);
        this.xpvprole.setExcellent(excellent);
        this.xpvprole.setLastentertime(now);
        if (isFirst) {
            if (excellent == 1) {
                LinkedList<String> strings = new LinkedList<String>();
                strings.add(PvP5Helper.getGradeName(grade));
                strings.add(PvP5Helper.getCampName(camp));
                MessageMgr.psendMsgNotifyWhileCommit((long)this.roleId, (int)172029, strings);
            } else {
                MessageMgr.psendMsgNotifyWhileCommit((long)this.roleId, (int)172034, null);
            }
            PvP5CampPolicy.addRoleNumByCamp(grade, camp);
        }
    }

    public int addScore(int addValue, boolean levelUp) {
        this.onAddScore(addValue);
        return addValue;
    }

    private void onAddScore(int addValue) {
        int lastScore = this.getScore();
        this.xpvprole.setScore(lastScore + addValue);
    }

    public void onBattleEnd(boolean isWin, long enemyId, int addScore, PvP5RaceProxy race) {
        RoleLiveness activeRole;
        if (this.readonly) {
            throw new UnsupportedOperationException("If readonly then cant invoke 5v5 onBattleEnd");
        }
        if (race.getXRace() == null) {
            return;
        }
        long now = System.currentTimeMillis();
        this.xpvprole.setLastbattletime(now);
        this.xpvprole.setLastentertime(now);
        if (isWin) {
            this.xpvprole.setWinnum(this.xpvprole.getWinnum() + 1);
            this.xpvprole.setContinuewinnum(Math.min(100, this.xpvprole.getContinuewinnum() + 1));
            if (this.xpvprole.getWinnum() == 1 && this.xpvprole.getFirstwinaward() == 0) {
                this.xpvprole.setFirstwinaward(1);
            }
        } else {
            this.xpvprole.setContinuewinnum(0);
        }
        this.xpvprole.setBattlenum(this.xpvprole.getBattlenum() + 1);
        if (this.xpvprole.getBattlenum() == 5 && this.xpvprole.getFivebattleaward() == 0) {
            this.xpvprole.setFivebattleaward(1);
        }
        if ((activeRole = RoleLiveness.getRoleLiveness((long)this.roleId)) != null) {
            activeRole.handleActiveLivenessData(242);
        }
        CourseManager.achieveCourse((long)this.roleId, (int)10, (int)242, (int)0);
        String roleName = Properties.selectRolename((Long)this.roleId);
        race.updateRankingList(this.roleId, roleName, addScore, this.xpvprole.getScore(), this.xpvprole.getBattlenum(), this.xpvprole.getWinnum());
        this.sendSPvP5MyInfo(now);
        if (!isWin && this.getExcellent() == 1 && this.getBattleNum() - this.getWinNum() >= 2) {
            this.dropGeneralScene();
        }
        if (PvP5Control.getLogger().isInfoEnabled()) {
            PvP5Control.getLogger().info((Object)("PVP5::[PvP5RoleProxy.onBattleEnd] roleId:" + this.roleId + " isWin:" + isWin + " enemyId:" + enemyId + " addScore:" + addScore + " score:" + this.xpvprole.getScore() + " continueWinNum:" + this.xpvprole.getContinuewinnum() + " winNum:" + this.xpvprole.getWinnum() + " battleNum:" + this.xpvprole.getBattlenum()));
        }
    }

    private void dropGeneralScene() {
        if (!PvP5Control.getInstance().isFightTime()) {
            return;
        }
        final int grade = this.getGrade();
        final int camp = this.getCamp();
        Procedure proc = new Procedure(){

            protected boolean process() {
                int mapId = PvP5Helper.getMapIdByRaceGrade(grade, false, camp);
                new PQuitTeamProc(PvP5RoleProxy.this.roleId).call();
                MapConfig mapConf = (MapConfig)ConfigManager.getInstance().getConf(MapConfig.class).get(mapId);
                Transfer.justGotoDeltaWhileCommit((long)PvP5RoleProxy.this.roleId, (long)mapId, (int)mapConf.getXjPos(), (int)mapConf.getYjPos(), (int)516017, (int)10);
                return true;
            }
        };
        Procedure.pexecuteWhileCommit((Procedure)proc);
        MessageMgr.sendMsgNotify((long)this.roleId, (int)172023, null);
        List<Long> ids = PvP5RoleProxy.getTeamMemberIds(this.roleId);
        ids.remove(this.roleId);
        if (ids.size() > 0) {
            String roleName = Properties.selectRolename((Long)this.roleId);
            Procedure.psendWhileCommit(ids, (Protocol)MessageMgr.getMsgNotify((int)172024, (int)0, (List)MessageMgr.getStringList((Object[])new Object[]{roleName})));
        }
    }

    public void sendSPvP5MyInfo(long waitStartTime) {
        SPvP5MyInfo snd = new SPvP5MyInfo();
        snd.firstwin = (byte)this.xpvprole.getFirstwinaward();
        snd.fivefight = (byte)this.xpvprole.getFivebattleaward();
        snd.battlenum = (byte)this.xpvprole.getBattlenum();
        snd.winnum = (byte)this.xpvprole.getWinnum();
        snd.combowinnum = (byte)this.xpvprole.getContinuewinnum();
        snd.score = this.xpvprole.getScore();
        snd.camp = (byte)this.xpvprole.getCamp();
        snd.waitstarttime = waitStartTime / 1000L;
        if (Transaction.current() != null) {
            Procedure.psendWhileCommit((long)this.roleId, (Protocol)snd);
        } else {
            Onlines.getInstance().send(Long.valueOf(this.roleId), (Protocol)snd);
        }
    }

    public boolean openBox(int boxType) {
        switch (boxType) {
            case 1: {
                if (this.xpvprole.getFirstwinaward() != 1) {
                    if (this.xpvprole.getFirstwinaward() == 0) {
                        MessageMgr.sendMsgNotify((long)this.roleId, (int)160342, (List)MessageMgr.getStringList((Object[])new Object[]{StringConstant.ID2String((String)"首胜奖励", (int)304)}));
                    } else {
                        MessageMgr.sendMsgNotify((long)this.roleId, (int)172000, (List)MessageMgr.getStringList((Object[])new Object[]{StringConstant.ID2String((String)"首胜奖励", (int)304)}));
                    }
                    return false;
                }
                RewardMgr.getInstance().distributeAllAward(this.roleId, 6251, null, YYLoggerTuJingEnum.tujing_Value_PVP5, 0, 4002, "首胜奖励");
                this.xpvprole.setFirstwinaward(2);
                Procedure.psendWhileCommit((long)this.roleId, (Protocol)new SPvP5OpenBoxState(1, 2));
                if (PvP5Control.getLogger().isInfoEnabled()) {
                    PvP5Control.getLogger().info((Object)("PVP5::[PvP5RoleProxy.openBox] roleId:" + this.roleId + " boxType:" + boxType + " firstWinAwardId:" + 6251));
                }
                return true;
            }
            case 2: {
                if (this.xpvprole.getFivebattleaward() != 1) {
                    if (this.xpvprole.getFivebattleaward() == 0) {
                        MessageMgr.sendMsgNotify((long)this.roleId, (int)160342, (List)MessageMgr.getStringList((Object[])new Object[]{StringConstant.ID2String((String)"五战奖励", (int)306)}));
                    } else {
                        MessageMgr.sendMsgNotify((long)this.roleId, (int)172000, (List)MessageMgr.getStringList((Object[])new Object[]{StringConstant.ID2String((String)"五战奖励", (int)306)}));
                    }
                    return false;
                }
                RewardMgr.getInstance().distributeAllAward(this.roleId, 6252, null, YYLoggerTuJingEnum.tujing_Value_PVP5, 0, 4002, "五战奖励");
                Procedure.psendWhileCommit((long)this.roleId, (Protocol)new SPvP5OpenBoxState(2, 2));
                this.xpvprole.setFivebattleaward(2);
                if (PvP5Control.getLogger().isInfoEnabled()) {
                    PvP5Control.getLogger().info((Object)("PVP5::[PvP5RoleProxy.openBox] roleId:" + this.roleId + " boxType:" + boxType + " tenFightAwardId:" + 6252));
                }
                return true;
            }
        }
        return false;
    }

    public static List<Long> getTeamMemberIds(long roleId) {
        Team team = TeamManager.selectTeamByRoleId((long)roleId);
        if (team != null) {
            return team.getNormalMemberIds();
        }
        ArrayList<Long> ids = new ArrayList<Long>();
        ids.add(roleId);
        return ids;
    }

    public static void notifyTeamProtocol(long roleId, Protocol send) {
        List<Long> ids = PvP5RoleProxy.getTeamMemberIds(roleId);
        Procedure.psendWhileCommit(ids, (Protocol)send);
    }

    public static void setTeamMemberPvPState(long roleId, int state) {
        List<Long> ids = PvP5RoleProxy.getTeamMemberIds(roleId);
        for (long id : ids) {
            PvP5RoleStateManager.getInstance().setRolePvPState(id, state);
        }
    }
}

